#ifndef _COBJLIST_H_
#define _COBJLIST_H_

#include "../Debug.h"
#include <list>
using namespace std;


template <class T>
class CObjectList
{
public:
	
	list<T*>		m_List; 
	unsigned int	m_ObjectHandle;
	int				m_NumObjects;
	T *				m_CurrentObject;

	bool			m_WantsRendered;

	CObjectList()
	{
		m_ObjectHandle	= 1;
		m_NumObjects	= 0;
		m_WantsRendered = true;

	}

	~CObjectList()
	{

	}

	bool ToggleRender()
	{
		if(m_WantsRendered)
			m_WantsRendered = false;
		else
			m_WantsRendered = true;

		return m_WantsRendered;
	}

		
	unsigned int AddObject()
	{
		T *nl0 = new T;
		nl0->SetHandle(m_ObjectHandle);
		m_List.push_back(nl0);
		
		m_CurrentObject = nl0;
		m_NumObjects	++;
		return m_ObjectHandle++;
	}

	unsigned int AddObject(T &_object)
	{
		T *nl0 = new T;
		(*nl0) = _object;
		nl0->SetHandle(m_ObjectHandle);
		m_List.push_back(nl0);
		
		m_CurrentObject = nl0;
		m_NumObjects	++;
		return m_ObjectHandle++;
	}


	bool DestroyObject()
	{	
		unsigned int handle = m_CurrentObject->GetHandle();
		
		list<T*>::iterator itter = m_List.begin();
		while( itter != m_List.end() )
		{
			if((*itter)->GetHandle() == handle)
			{
				delete (*itter);
				m_List.erase( itter );
				m_NumObjects	--;
				m_CurrentObject = NULL;
				return true;
			}	
			++itter;
		}
		return false;
	}
	
	T* GetObject(unsigned int _handle)
	{
		list<T*>::iterator itter = m_List.begin();
		
		while( itter != m_List.end() )
		{
			if((*itter)->GetHandle() == _handle)
			{
				return (*itter);
			}
			++itter;
		}
		return NULL;
	}
	
	bool WriteToFile(ofstream *fileOut)
	{	
		int n = m_NumObjects;
		fileOut->write((char *)(&n), sizeof(int));
		T temp;
		list<T*>::iterator itter = m_List.begin();
		while( itter != m_List.end() )
		{		
			temp = *(*itter);
			fileOut->write((char *)(&temp), sizeof(T));
			++itter;
		}
		return true;
	}
	
	
	bool ReadFromFile(ifstream *fileIn)
	{
		
		int i=0,n;
		fileIn->read((char *)(&n), sizeof(int));	
		T temp;
		while( i++ < n )
		{		
			fileIn->read((char *)(&temp), sizeof(T));	
			AddObject();			
			(*m_CurrentObject) = temp;
		}
		
		return true;
		
	}
	
	bool Render()
	{
		if(m_WantsRendered==false)
			return false;
		
		list<T*>::iterator itter = m_List.begin();
		while( itter != m_List.end() )
		{		
			(*itter)->Render();
			++itter;
		}
		return true;
	}



	bool Unload()
	{
		list<T*>::iterator itter ;
		for( itter = m_List.begin(); itter != m_List.end(); )
		{
			T * Temp = *itter;
			itter = m_List.erase(itter);
			delete Temp;			
		}
		return true;
	}

};

#endif