//=======================================================================================
// CStaticList.cpp  | April 2004 | Chris McLaughlin
//---------------------------------------------------------------------------------------
//
//	A templated Abstract Data Type.
//	Kindof a cross between an array and linked list.
//
//	Needed something  listesque  but  without  slow memory read/writes,
//	so all the memory  is  allocated  when the  staticlist  is created.
//  the 'Active' list is like  a  linked  list, but instead of creating 
//	new or deleteing nodes, it takes/replaces them from the 'Available'
//	list.   If there are none available,  you don't get any, but you do 
//	get a nice NULL pointer.
//
//	The 'Available' list should never be needed by the user,  as it's a 
//	local interpretation of a protected memory area,  So they can't get 
//	at it. 
//
//	Also:   this file is 'king ugly, i should tidy it up.  'king templates.
//			still, it's better than 'king gary.
//---------------------------------------------------------------------------------------

#ifndef _STATICLIST_H_
#define _STATICLIST_H_

#include <stdio.h>//defines NULL

//*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*
//#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#

#define ARSINGDEGUGVALUE		(5000)

//*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*
//#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#*#

template < class T >
class CStaticList
{

public:
	typedef struct _CSLnode
	{
		T			data;
		_CSLnode *	next;
		_CSLnode *	prev;
		bool		state;

	}CSLnode;


	int			GetSize()		{ return m_ListSize; }
	int			GetAvailable()	{ return m_TotalNodes - m_ListSize; }
	CSLnode*	GetHead()		{ return m_ActiveHead; }


	 CStaticList()
	 {
		int _numNodes				= ARSINGDEGUGVALUE;

		int n=1;
			m_TotalNodes		= _numNodes;
			m_ListSize			= 0;
		CSLnode * theNewNode;
		CSLnode * temp;

		
		temp					= new(CSLnode);
		temp->prev				= NULL;
			
		m_AvailableHead			= temp;

		while(n++<m_TotalNodes)
		{
			theNewNode			= new(CSLnode);
			temp->next			= theNewNode;
			theNewNode->prev	= temp;
			theNewNode->state	= 0;

			temp = theNewNode;			
		};	 
		
		temp->next = NULL;
		m_ActiveHead = NULL;
	 }

	~CStaticList()
	{
		CSLnode * togo;
		CSLnode * temp;

		temp = m_AvailableHead;
		while(temp!=NULL)
		{
			togo = temp;
			temp = togo->next;
			delete(togo);
			m_TotalNodes--;
		}
		m_AvailableHead = NULL;

		temp = m_ActiveHead;
		while(temp!=NULL)
		{
			togo = temp;
			temp = togo->next;
			delete(togo);
			m_TotalNodes--;
			m_ListSize--;
		}
		m_ActiveHead=NULL;
	}

	CSLnode* Add()
	{
		if(m_AvailableHead != NULL)
		{	
			CSLnode * temp;
			temp = m_AvailableHead;
			
			m_AvailableHead			= m_AvailableHead->next;
			temp->next				= m_ActiveHead;
			temp->prev				= NULL;
			if(m_ActiveHead !=NULL)
				m_ActiveHead->prev	= temp;
			m_ActiveHead = temp;
			
			if((m_AvailableHead != NULL) && (m_AvailableHead->next != NULL))
				m_AvailableHead->next->prev = m_AvailableHead;

			m_ActiveHead->state		= 1;
			m_ListSize++;
			return m_ActiveHead;
		}
		return NULL;
	}

	CSLnode* Add(T &_data)
	{
		this->Add();
		m_ActiveHead->data = _data;
		return m_ActiveHead;
	}

	bool Remove(CSLnode* node)
	{	
		if ((node != NULL) && (node->state == 1) )
		{
			if(node->next != NULL)			//node not tail
				node->next->prev	= node->prev;

			if(node->prev != NULL)			//node not head
				node->prev->next	= node->next;
			else
				m_ActiveHead			= node->next;

			node->next				= m_AvailableHead;
			node->state				= 0;

			m_AvailableHead			= node;

			m_ListSize--;
			return true;
		}
		return false;
	}

private:
	int m_TotalNodes;
	int m_ListSize;
	CSLnode * m_ActiveHead;
	CSLnode * m_AvailableHead;
};



#endif