#ifndef _SPRING_H_
#define _SPRING_H_

#include "..\Maths\maths.h"

#define MAXNUMENDS		(2)
#define	STRINGNODES		(25)
#define STRINGLENGTH	(25)
#define SPRINGTOLERANCE (0.000005f)


class CMassCentre
{
private:
	vec3f	m_Velocity,
			m_Force;
	float	m_Mass;
	vec3f	m_Position;

public:

	CMassCentre();
	void ResetForce();
	void ApplyForce(vec3f outsideForce);
	void SpringForce(vec3f &otherEnd, float K, float deltaDist, vec3f &fout);
	void SetForceInvert(vec3f &force);
	void Update(float deltaT, float friction);

	//get/set
	void SetPosition(vec3f &tothis);
	void SetPosition(float x, float y, float z);
	void SetMass(float m);

	vec3f GetPosition();
	float GetMass();
};

class CSpring
{
private:
	CMassCentre *m_Ends[MAXNUMENDS];

	float	K,
			length;

public:
		 CSpring();
	void SetEnds(CMassCentre *left, CMassCentre *right);
	void Set(float k_coefficient, float sprlength);
	void SolveForces();
	void Solve0();
	void Solve1();
	void ApplyForce(vec3f &force);	
};

class CSingleSpring : public CSpring
{
	CMassCentre left, right;

public:
	CSingleSpring();
	void AnchorLeft(vec3f &toHere);
	void Solve();
	void SolveRight();
	void SolveRight(vec3f &OutsideForce);
	void Solve(vec3f &OutsideForce);
	void Update(float deltaT, float friction);
	vec3f GetLeft();
	vec3f GetRight();

};

#endif