#include "Timer.h"

bool CTimer::Init(void) 
{
  __int64 rate;

  // we need the accuracy
  if(!QueryPerformanceFrequency((LARGE_INTEGER*)&rate)) 
  {
    return false; // windows errors
  }

  // usually the rate will be 1193180
  if(!rate) 
  {
    return false;
  }

  rate_inv=1.0/(double)rate;

  if(!QueryPerformanceCounter((LARGE_INTEGER*)&startclock))
  {
    return false; // windows errors
  }

  last = 0;

  return true; // there is a clock
}

double CTimer::Time(void) 
{
  // by dividing by timers rate you get accurate seconds

  __int64 endclock;

  QueryPerformanceCounter((LARGE_INTEGER*)&endclock);

  return (double)(endclock-startclock)*rate_inv;

  // note: I recommend that you multiply but the inverse of a constant.
  // (speed reasons)
}

double CTimer::Tick(void) 
{
	double t  = Time();
	double tk = t - last;
	last = t;

	return tk;
}