#ifndef _EMITER_H_
#define _EMITER_H_

#include "../../Objects/Object.h"
#include "../../ADT/CStaticList.h"
#include "../../ADT/ListedObject.h"
#include "CParticle.h"


class CEmitter : public CObject, public CListedObject
{
public:
	int		m_NumParticles,
			m_Loops;
	bool	m_Visible,
			m_Alive,
			m_DontDestroy;

	vec3f m_Velocity;
	// Values for creating new particles

	// Values for new particles
	//		baseValue   |	variance
	float	m_Speed,		m_SpeedVar,
			m_Mass,			m_MassVar,
			m_Elasticity,	m_ElasticityVar,
			m_ScaleP,		m_ScalePVar;
	float	m_Age,			m_AgeVar;
	bool	m_Collides;
	col4f	m_Colour,		m_ColourVar,		m_EndColour;

	unsigned int			m_Texture;

	// Values for updating particles
	vec3f	m_LocalForce;	// Probably gravity
	float	m_Friction;		// Probably air resistance
	
	// Values for rendering
	vec3f	m_Up, m_Right, m_Front;

	// Listy things
	CStaticList<CParticle>::CSLnode	* m_pStart;
	CStaticList<CParticle>			* m_List;

public:
	CEmitter(CStaticList<CParticle> *_pile);
	~CEmitter();
	bool Init();
	bool Restart();
	int  Update(void* _arg);
	bool Emit(CStaticList<CParticle>::CSLnode *_me);
	void Render(bool _reflected = false);
	void RenderLines();
	bool Destroy();
};


#endif