#include "CParticle.h"
#include "../../Globals.h"

CParticle::CParticle()
{
	Init();
}

CParticle::~CParticle()
{
	//*CEmitter m_Spawnedby = NULL;
}

bool CParticle::Init(/**CEmitter _Spawnedby*/)
{
	//if(!_Spawnedby){
	//*CEmitter m_Spawnedby = NULL;
	//get setups
	//}else
	m_Position.Set	(0,0,0);
	m_Rotation.Set	(0,0,0);
	m_Scale.Set		(0.1f,0.1f,0.1f);
	m_Velocity.Set	(0,0,0);
	m_Mass			= 1.0f;
	m_Elasticity	= 1.0f;
	m_Age			= 1.0f;
	m_Alive			= false;
	m_Deaths		= 0;
	m_Collide		= false;
	m_Colour.Set	(1,1,1,1);
	m_Texture		= 0;
	return true;
}

int CParticle::Update(void* _arg)
{
	float tp = float(*(double*) _arg);
	if((m_Age -= tp) < 0) 
	{
		m_Deaths++;
		return born_again;
	}


	m_Position += m_Velocity;

	if( (m_Collide) && (m_Position.y <= 0) && (m_Velocity.y < 0))
		m_Velocity.y *= m_Elasticity;

	m_Colour = m_EndColour.Lerp(m_StartColour, (m_Age * m_OneOverAge));

	return is_ok;
}

void CParticle::ApplyForce(vec3f &_force)
{
	m_Velocity += _force * m_Mass;
}

void CParticle::ApplyFriction(float _f)
{
	m_Velocity *= _f;
}

void CParticle::Render(vec3f &_Up, vec3f &_Right,vec3f &_Normal)
{	
	if(!m_Alive) return;

	glColor4f(m_Colour.r, m_Colour.g, m_Colour.b, m_Colour.a);
	glBindTexture( GL_TEXTURE_2D, m_Texture);

	glBegin(GL_TRIANGLE_STRIP);
	{

	glNormal3f(_Normal.x, _Normal.y, _Normal.z);
	
	glTexCoord2f(0.0f, 0.0f);
	glVertex3f(	m_Position.x + (_Right.x * -m_Scale.x) + (_Up.x * -m_Scale.x),
				m_Position.y + (_Right.y * -m_Scale.x) + (_Up.y * -m_Scale.x),
				m_Position.z + (_Right.z * -m_Scale.x) + (_Up.z * -m_Scale.x));
	
	glTexCoord2f(1.0f, 0.0f);
	glVertex3f(	m_Position.x + (_Right.x * m_Scale.x)  + (_Up.x * -m_Scale.x),
				m_Position.y + (_Right.y * m_Scale.x)  + (_Up.y * -m_Scale.x),
				m_Position.z + (_Right.z * m_Scale.x)  + (_Up.z * -m_Scale.x));
	
	glTexCoord2f(0.0f, 1.0f);
	glVertex3f(	m_Position.x + (_Right.x * -m_Scale.x) + (_Up.x * m_Scale.x),
				m_Position.y + (_Right.y * -m_Scale.x) + (_Up.y * m_Scale.x),
				m_Position.z + (_Right.z * -m_Scale.x) + (_Up.z * m_Scale.x));
	
	glTexCoord2f(1.0f, 1.0f);
	glVertex3f(	m_Position.x + (_Right.x * m_Scale.x)  + (_Up.x * m_Scale.x),
				m_Position.y + (_Right.y * m_Scale.x)  + (_Up.y * m_Scale.x),
				m_Position.z + (_Right.z * m_Scale.x)  + (_Up.z * m_Scale.x));	

	}
	glEnd();
}

