#ifndef _PARTICLES_H
#define _PARTICLES_H

#include "../../Maths/Maths.h"
#include "../../Objects/Object.h"

enum {is_ok, born_again, really_dead};

class CParticle : public CObject
{
public:

	vec3f	m_Velocity;
	float	m_Mass,
			m_Elasticity,
			m_Age,
			m_OneOverAge;
	bool	m_Alive,
			m_Collide;
	int		m_Deaths;

	col4f	m_Colour, m_StartColour, m_EndColour;
	int		m_Texture;

	//*CEmitter m_Spawnedby;

	CParticle();
	~CParticle();

	bool	Init();
	int		Update(void*);
	void	ApplyForce(vec3f &_force);
	void	ApplyFriction(float _f);
	void	Render(vec3f &_Up, vec3f &_Right,vec3f &_Normal);

//	virtual bool Init() = 0;
//	virtual bool Update( void* ) = 0;
	bool Destroy(){return true;}

};



#endif