#ifndef _TRAIL_H_
#define _TRAIL_H_

#include "../../Objects/Object.h"



class CTrailPoint
{
	
public:
	vec3f	m_Position,
			m_SlideVec;

	CTrailPoint();
	void	SetPos(vec3f &_v);

};

class CTrail: public CObject
{
protected:
public:
	int			m_Resolution;
	CTrailPoint	*m_Point;
	col4f		*m_Colour;
	float		m_DistApart_Sq;
	int			m_LastPoint;
	float		m_ResMul;

	unsigned int m_Handle;
	unsigned int m_Texture;


	 CTrail();
	 ~CTrail();

	void Build(vec3f &_camPosition);
	void Render();
	void RenderLines();

	void SetHandle(unsigned int i);
	unsigned int GetHandle();

	virtual bool Init();
			bool Init(float _lengthInUnits, int _resolution, unsigned int _texture, vec3f &_pos, col4f &_basecol, vec3f &_scale);	
	virtual int  Update( void* );
			bool UpdateFlat(vec3f &_vel);
	virtual bool Destroy();
};

class CTrailTimed : public CTrail
{
	double m_TimeApart;
	double m_Timer;

public:
	virtual bool Init();
			bool Init(float _lengthInSeconds, int _resolution, unsigned int _texture, vec3f &_pos, col4f &_basecol, vec3f &_scale);	
	virtual int  Update( void* _arg );
	virtual bool Destroy();
			void Render();
};




#endif