#ifndef _PLAYER_H_
#define _PLAYER_H_

#include "../Maths/Maths.h"
#include "../Objects/Object.h"
#include "../Render/Render.h"
#include "Level.h"
#include "../FX/Trails/CTrail.h"

enum EDirection {North, South, East, West, Up, Down};

class CPlayer : public CObject
{
public:

	int			m_Score;
	col4f		m_BaseColour;
	vec3f		m_Velocity;
	vec3f		m_MaxVelocity;
	vec3f		m_Acceleration;
	vec3f		m_MaxAcceleration;
	float		m_BaseLine;
	float		m_SurfaceFriction;
	EDimension	m_BaseAxis;
	CTrailTimed	m_Trail;

	EDirection	m_AIDir;
		

	virtual	bool Init();
			bool Init(vec3f &_pos, col4f &_col, EDimension _baseDim, EDirection _dir);
			void AIThink(vec3f &_PuckPos, vec3f &_PuckVel);
			void Move(float x, float z);
			void MMove(float x, float z);
			bool Thrust(float _magnitude);
	virtual	int  Update( void* );
			void Render(bool _doTrail = true);
	virtual	bool Destroy();

	vec3f GetVel()				{ return m_Velocity; }
	void SetVel(vec3f &_v)		{ m_Velocity = _v; }

	float GetScale(EDimension _d)	
	{ 
		switch(_d)
		{
		case X: return m_Scale.x;
		case Y: return m_Scale.x;
		case Z: return m_Scale.x;
		}
		return 0;
	}

};

#endif