#include "colDefault.h"




//////////////////////
//	Constructors	//
//////////////////////

col3f::col3f( void )
{
	r = 0.0f;
	g = 0.0f;
	b = 0.0f;
}

col3f::col3f( float _nr, float _ng, float _nb )
{
	if (_nr > 1.0f) _nr = 1.0;
	if (_nr < 0.0f) _nr = 0.0;
	r = _nr;

	if (_ng > 1.0f) _ng = 1.0;
	if (_ng < 0.0f) _ng = 0.0;
	g = _ng;

	if (_nb > 1.0f) _nb = 1.0;
	if (_nb < 0.0f) _nb = 0.0;
	b = _nb;
}

col3f::col3f( col3f * _param )
{
	r = _param->r;
	g = _param->g;
	b = _param->b;
}

col3f::col3f( col4f * _param )
{
	r = _param->r;
	g = _param->g;
	b = _param->b;
}

col3f::col3f( int _nr, int _ng, int _nb )
{
	if (_nr > 255)	_nr = 255;
	if (_nr < 0)	_nr = 0;
	r = (float)_nr / 255;

	if (_ng > 255)	_ng = 255;
	if (_ng < 0)	_ng = 0;
	g = (float)_ng / 255;

	if (_nb > 255)	_nb = 255;
	if (_nb < 0)	_nb = 0;
	b = (float)_nb / 255;
}

col3f::col3f( int _colour)
{
	*this = setColour( _colour );
}

//////////////////
//	Operators	//
//////////////////

col3f col3f::operator = ( col3f * _param )
{
	r = _param->r;
	g = _param->g;
	b = _param->b;

	return (*this);
}



//////////////////
//	Methods		//
//////////////////

void col3f::Set( float _nr, float _ng, float _nb)
{
	if (_nr > 1.0f) _nr = 1.0;
	if (_nr < 0.0f) _nr = 0.0;
	r = _nr;

	if (_ng > 1.0f) _ng = 1.0;
	if (_ng < 0.0f) _ng = 0.0;
	g = _ng;

	if (_nb > 1.0f) _nb = 1.0;
	if (_nb < 0.0f) _nb = 0.0;
	b = _nb;
}

void col3f::Set( int _nr, int _ng, int _nb)
{
	if (_nr > 255)	_nr = 255;
	if (_nr < 0)	_nr = 0;
	r = (float)_nr / 255;

	if (_ng > 255)	_ng = 255;
	if (_ng < 0)	_ng = 0;
	g = (float)_ng / 255;

	if (_nb > 255)	_nb = 255;
	if (_nb < 0)	_nb = 0;
	b = (float)_nb / 255;
}

void col3f::Set( col3f * _param )
{
	r = _param->r;
	g = _param->g;
	b = _param->b;
}

col3f col3f::Lerp( col3f &v2, float s )
{
	col3f temp;

	temp.r= r + ( v2.r - r ) * s;
	temp.g= g + ( v2.g - g ) * s;
	temp.b= b + ( v2.b - b ) * s;
	return( temp );
}
