#include "maths.h"

void planef::Normalise( void )
{
	float mag = 1/sqrtf((m_equ.x*m_equ.x) + (m_equ.y*m_equ.y) + (m_equ.z*m_equ.z));
	m_equ *= mag;
}

float planef::DistanceToPoint( vec3f * _point )
{
	return ( (m_equ.x * _point->x) + (m_equ.y * _point->y) + (m_equ.z * _point->z) + m_equ.a );
}

float planef::DistanceToPoint( vec4f * _point )
{
	return ( (m_equ.x * _point->x) + (m_equ.y * _point->y) + (m_equ.z * _point->z) + m_equ.a );
}

halfspace planef::CheckPoint( vec3f * _point )
{
	float d;

	d = (m_equ.x * _point->x) + (m_equ.y * _point->y) + (m_equ.z * _point->z) + m_equ.a;

	if (d < 0) return NEGATIVE;
	if (d > 0) return POSITIVE;
	return ON_PLANE;
}

halfspace planef::CheckPoint( vec4f * _point )
{
	float d;

	d = (m_equ.x * _point->x) + (m_equ.y * _point->y) + (m_equ.z * _point->z) + m_equ.a;

	if (d < 0) return NEGATIVE;
	if (d > 0) return POSITIVE;
	return ON_PLANE;
}

bool planef::BoxTotPosCheck( vec3f _corners[8] )
{
	int iInCount = 8;
	for(int i = 0; i < 8; ++i) {
		// test this point against the planes
		if(CheckPoint(&_corners[i]) == POSITIVE) {
			--iInCount;
		}
	}
	if(iInCount == 0) return true;
	return false;
}

bool planef::BoxTotNegCheck( vec3f _corners[8] )
{
	int iInCount = 8;
	for(int i = 0; i < 8; ++i) {
		// test this point against the planes
		if(CheckPoint(&_corners[i]) == NEGATIVE) {
			--iInCount;
		}
	}
	if(iInCount == 0) return true;
	return false;
}
