#ifndef _QUAT_H_
#define _QUAT_H_

class quatf
{
public:
	float w, x, y, z;

	quatf operator + ( quatf );
	quatf operator += ( quatf );
	quatf operator - ( quatf );
	quatf operator -= ( quatf );
	quatf operator * ( quatf );
	quatf operator *= ( quatf );
	quatf operator * ( float );
	quatf operator *= ( float );
	quatf operator / ( float );
	quatf operator /= ( float );
	quatf operator ~ ( void );

	quatf( void );
	quatf( float _nw, float _nx, float _ny, float _nz );
	quatf( mat3f * _param );
	quatf( mat4f * _param );

	void Set( float nw, float nx, float ny, float nz );
	quatf Conjugate( void );
	float Magnitude( void );
	void Normalize( void );
	void RotateBy( quatf param );
	float GetAngle( void );
	vec3f GetAxis( void );
	void FromAxisAngle( vec3f * rAxis, float fAngle );
	void FromEulers( float fX, float fY, float fZ );
	vec3f GetEulers( void );
	quatf Lerp( quatf rQuat, float fInterp );
	quatf Slerp( quatf rQuat, float fInterp );
};
#endif