#include "maths.h"

vec2f vec2f::operator = (vec2f * _param)
{
	return vec2f(x=_param->x, y=_param->y);
}

//-------------------------------------------------------
//-------------------------------------------------------

vec2f::vec2f( void )
{
	x = 0.0f;
	y = 0.0f;
}

vec2f::vec2f( float _nx, float _ny )
{
	x = _nx;
	y = _ny;
}

vec2f::vec2f( vec2f * _param )
{
	x = _param->x;
	y = _param->y;
}

//-------------------------------------------------------
//-------------------------------------------------------

void vec2f::Set( float nx, float ny )
{
	x = nx;
	y = ny;
}

float vec2f::Length()
{
	return SQRT(SQR(x) + SQR(y));
}

float vec2f::LengthNoRoot()
{
	return (SQR(x) + SQR(y));
}

void vec2f::Scale (float s)
{
	x= x * s;
	y= y * s;
}

void vec2f::Normalize()
{
	Scale(1.0f / Length() );
}

vec2f vec2f::Negative( void )
{
	vec2f temp;

	temp.x = -x;
	temp.y = -y;

	return ( temp );
}
