#ifndef _vec3f_H_
#define _vec3f_H_

class vec3f
{
public:
	float x,y,z;

	vec3f operator=(vec3f * _param);
	float& operator[]( const long i ){return *((&x) + i);}

	vec3f( void );
	vec3f( float _nx, float _ny, float _nz );
	vec3f( vec3f * _param );
	vec3f( vec4f * _param );

	void Set( float nx, float ny, float nz );
	void Set( vec3f & _param );
	void Set( vec4f & _param );
	float Length();
	float LengthNoRoot();
	void Scale ( float s );
	void Normalize();
	float DotProduct ( vec3f &v2 );
	vec3f CrossProduct ( vec3f &v2 );
	vec3f Lerp ( vec3f &v2, float s );
	float SeperationXZ ( int nx, int nz );
	vec3f Negative( void );
	void RotateAround(vec3f &_around, float angle);
};

inline vec3f operator+(vec3f const &a,vec3f const &b)	{return vec3f(a.x+b.x,a.y+b.y,a.z+b.z);}
inline vec3f operator+=(vec3f &a,vec3f const &b)		{a.x+=b.x;a.y+=b.y;a.z+=b.z;return a;}
inline vec3f operator-(vec3f const &a,vec3f const &b)	{return vec3f(a.x-b.x,a.y-b.y,a.z-b.z);}
inline vec3f operator-=(vec3f &a,vec3f const &b)		{a.x-=b.x;a.y-=b.y;a.z-=b.z;return a;}
inline vec3f operator*(vec3f const &a,float const &b)	{return vec3f(a.x*b,a.y*b,a.z*b);}
inline vec3f operator*(float const &a,vec3f const &b)	{return vec3f(a*b.x,a*b.y,a*b.z);}
inline vec3f operator*(vec3f const &a,vec3f const &b)	{return vec3f(a.x*b.x,a.y*b.y,a.z*b.z);}
inline vec3f operator*=(vec3f &a,vec3f const &b)		{a.x*=b.x;a.y*=b.y;a.z*=b.z;return a;}
inline vec3f operator*=(vec3f &a,float const &b)		{a.x*=b;a.y*=b;a.z*=b;return a;}
inline vec3f operator/(vec3f const &a,float const &b)	{return vec3f(a.x/b,a.y/b,a.z/b);}
inline vec3f operator/(float const &a,vec3f const &b)	{return vec3f(a/b.x,a/b.y,a/b.z);}
inline vec3f operator/(vec3f const &a,vec3f const &b)	{return vec3f(a.x/b.x,a.y/b.y,a.z/b.z);}
inline vec3f operator/=(vec3f &a,vec3f const &b)		{a.x/=b.x;a.y/=b.y;a.z/=b.z;return a;}
inline vec3f operator/=(vec3f &a,float const &b)		{a.x/=b;a.y/=b;a.z/=b;return a;}
inline bool  operator==(vec3f &a,vec3f const &b)		{if((fabs(a.x-b.x)<=EQUALENOUGH)&&(fabs(a.y-b.y)<=EQUALENOUGH)&&(fabs(a.z-b.z)<=EQUALENOUGH)) return 1;else return 0;}

#endif