#ifndef _COBJECT_H_
#define _COBJECT_H_

#include "../Maths/maths.h"

#define OBJ_COMET_RED	1
#define OBJ_COMET_BLUE	2

enum EDimension {X, Y, Z, NONE};

class CObject
{
public:

	unsigned int	m_ID;

	vec3f m_Position;
	vec3f m_Rotation;
	vec3f m_Scale;

	void SetPos(vec3f _v)	{ m_Position = _v;	}
	void SetRot(vec3f _v)	{ m_Rotation = _v;	}
	void SetScale(vec3f _v) { m_Scale = _v;		}
	vec3f GetPos()			{ return m_Position;}
	vec3f GetRot()			{ return m_Rotation;}
	vec3f GetScale()		{ return m_Scale;	}
	float GetScale(EDimension _d)	
	{ 
		switch(_d)
		{
		case X: return m_Scale.x;
		case Y: return m_Scale.x;
		case Z: return m_Scale.x;
		}
		return 0;
	}

	// must be implemented for all object derivations
	virtual bool Init() = 0;
	virtual int Update( void* ) = 0;
	virtual bool Destroy() = 0;
};

#endif