#include "Render.h"

void CRenderer::SetCamera(CCamera * _pActiveCamera)
{
//	mat4f camViewMatrix;

	_pActiveCamera->BuildMatrix();
	_pActiveCamera->GetMatrixNoBuild(MATRIX_MODELVIEW, m_CamViewMatrix);
	glMultMatrixf(m_CamViewMatrix.cell[0]);

	// Get ready for billboards
	GetBillBoardVectors(m_Up, m_Right, m_Face);
}


void CRenderer::GetBillBoardVectors(vec3f &_up, vec3f &_right, vec3f &_normal)
{	
	// get the up/right vectors of transposed matrix
	_up.x = m_CamViewMatrix.cell[0][1];
	_up.y = m_CamViewMatrix.cell[1][1];
	_up.z = m_CamViewMatrix.cell[2][1];
	
	_right.x = m_CamViewMatrix.cell[0][0];
	_right.y = m_CamViewMatrix.cell[1][0];
	_right.z = m_CamViewMatrix.cell[2][0];
	
	//Calc Normal
	_normal= _right.CrossProduct(_up);

	//Mormalise
	_normal.Normalize();

}