#ifndef _RENDER_H_
#define _RENDER_H_

#include "../Core/GLCore.h"
#include "../Maths/Maths.h"
#include "../Camera/Camera.h"
#include "Texture.h"

class CRenderer
{
public:	

	GL_Window		*m_window;
	TextureManager	m_TextureMan;
	bool			m_ReflectEnabled;
	mat4f			m_CamViewMatrix;
	vec3f			m_Up, m_Right, m_Face;

	int				m_PTex;

	void RenderLine(vec3f &_start, vec3f &_end, float _width);
	void RenderCircle(float _radius, float _resolution, float _lineWidth);
	void RenderDisc(float _radius, float _resolution);
	void RenderCylinder(float _radius, float _resolution, float height);
	void RenderPlane(float _width, float _height, float _res, unsigned int _texture);
	void RenderCube(float _scale, unsigned int _texture);
	void RenderCuboid(vec3f &_scale, unsigned int _texture);
	void SetCamera(CCamera * _pActiveCamera);
//	void RenderGLUTSphere(){ glutSolidSphere(1,1,1); }

	void RenderAxes(float _scale, float _width, float _alpha = 1.0f);
	
	void GetBillBoardVectors(vec3f &_up, vec3f &_right, vec3f &_normal);
};


//void RenderPlane(float _width, float _height, float _res, unsigned int _texture);
//void RenderCube(float _scale, unsigned int _texture);
//void RenderCuboid(vec3f &_scale, unsigned int _texture);
//void SetCamera(CCamera * _pActiveCamera);

#endif